# comment out if not a git snapshot
#define git		git20190309

%define uname		cutter

# Translation files are in a separate project
# https://github.com/radareorg/cutter-translations
%define tr_commit	8358f174d519bbf0d6cf4e1ccbe586308c009f85

%define rel 1

%global toolchain clang

Name:		radare2-cutter
Epoch:		1
Version:	2.3.4
Release:	%mkrel %{?git:0.%git.}%{rel}
Summary:	A Qt and C++ GUI for radare2 reverse engineering framework
License:	GPLv3+
Group:		Development/Tools
Url:		https://www.radare.org/
Source0:	https://github.com/rizinorg/cutter/archive/v%{version}/%{uname}-%{version}.tar.gz
Source1:	https://github.com/rizinorg/cutter-translations/archive/%{tr_commit}.tar.gz

BuildRequires:	pkgconfig(capstone)
BuildRequires:	pkgconfig(libgvc)
BuildRequires:	pkgconfig(python3)
BuildRequires:	pkgconfig(r_core)
BuildRequires:	pkgconfig(rz_core) >= 0.7.0

BuildRequires:	cmake(Qt6Core5Compat)
BuildRequires:	cmake(Qt6Core)
BuildRequires:	cmake(Qt6Gui)
BuildRequires:	cmake(Qt6Network)
BuildRequires:	cmake(Qt6OpenGLWidgets)
BuildRequires:	cmake(Qt6Svg)
BuildRequires:	cmake(Qt6SvgWidgets)
BuildRequires:	cmake(Qt6Widgets)
BuildRequires:	cmake(Qt6LinguistTools)
BuildRequires:	cmake(PySide6)
BuildRequires:	cmake(Shiboken6)
#BuildRequires:	cmake(KF6SyntaxHighlighting)

BuildRequires:	cmake
%if "%{toolchain}" == "clang"
BuildRequires:	clang
%endif

Requires:	radare2
Requires:	rizin-common
Provides:	%{uname} = %epoch:%{version}-%{release}
Provides:	cutter = %epoch:%{version}-%{release}

%description
A Qt and C++ GUI for radare2 reverse engineering framework
(originally named Iaito).

Cutter is not aimed at existing radare2 users. It instead focuses
on those whose are not yet radare2 users because of the learning
curve, because they don't like CLI applications or because of the
difficulty/instability of radare2.

#------------------------------------------------------------------------------

%package devel
Summary:	Development files for the rizin package
Group:		Development/Tools
Requires:	%{name}%{?_isa} >= %epoch:%{version}-%{release}

%description devel
Development files for the rizin package. See rizin package for more
information.

#------------------------------------------------------------------------------

%prep
%autosetup -p1 -n %{uname}-%{version} -a1

# Prepare translation files
mv cutter-translations-%{tr_commit}/* src/translations/

%build
export LLVM_INSTALL_DIR="%{_prefix}"
%cmake -DCUTTER_QT6=ON \
       -DCUTTER_USE_BUNDLED_RIZIN=OFF \
       -DCUTTER_USE_ADDITIONAL_RIZIN_PATHS=OFF \
       -DCUTTER_ENABLE_PYTHON=ON \
       -DCUTTER_ENABLE_PYTHON_BINDINGS=ON \
       -DPYSIDE_INCLUDE_DIRS=%{_includedir}/PySide6 \
       -DPYSIDE_TYPESYSTEMS=%{_datadir}/PySide6/typesystems
%if 0
pushd src
%{_qt6_bindir}/lrelease translations/*.ts
popd
%endif
%cmake_build

%install
%cmake_install

%files
%doc CONTRIBUTING.md README.md docs/*
%license COPYING
%{_bindir}/cutter
%{_datadir}/applications/re.rizin.cutter.desktop
%{_iconsdir}/hicolor/scalable/apps/cutter.svg
%{_datadir}/rizin/cutter/

%files devel
%_includedir/cutter/
%{_libdir}/cmake/Cutter/


%changelog
* Sun Apr 21 2024 daviddavid <daviddavid> 1:2.3.4-1.mga10
+ Revision: 2060410
- build using clang toolchain
- new version: 2.3.4
- rebuild for new rizin 0.7.3

* Wed Jan 24 2024 daviddavid <daviddavid> 1:2.3.2-1.mga10
+ Revision: 2034121
- new version: 2.3.2
- switch to Qt6, Pyside6 and Shiboken6
- rebuild for py3.12

* Mon Jul 03 2023 papoteur <papoteur> 1:2.2.1-2.mga9
+ Revision: 1963538
- Rebuild for new rizin

* Mon Jul 03 2023 daviddavid <daviddavid> 1:2.2.1-1.mga9
+ Revision: 1963533
- new version 2.2.1 (for rizin 0.5.2)
- enable KF5SyntaxHighlighting and PySide2 support
- rebuild for new rizin

* Mon Jan 02 2023 daviddavid <daviddavid> 1:2.1.2-3.mga9
+ Revision: 1929337
- rebuild for new radare2
- add missing dependency on rizin-common
- own cmake lib dir

* Tue Oct 11 2022 papoteur <papoteur> 1:2.1.2-2.mga9
+ Revision: 1896232
- Fix devel package requirement, should include epoch of library

* Mon Oct 10 2022 papoteur <papoteur> 1:2.1.2-1.mga9
+ Revision: 1896171
- new 2.1.2
- Rebuild for rizin 0.4.0

* Fri Jun 24 2022 papoteur <papoteur> 1:2.0.4-3.mga9
+ Revision: 1865843
- Mass Rebuild for dependencies

* Tue Apr 05 2022 umeabot <umeabot> 1:2.0.4-2.mga9
+ Revision: 1845371
- Mageia 9 Mass Rebuild

* Mon Jan 03 2022 neoclust <neoclust> 1:2.0.4-1.mga9
+ Revision: 1766379
- New version 2.0.4

* Wed Mar 24 2021 neoclust <neoclust> 1:0.1.1-1.mga9
+ Revision: 1709637
- Switch to r2cutter fork
- Rebuild against new radare2

* Tue Dec 22 2020 daviddavid <daviddavid> 1.12.0-1.mga8
+ Revision: 1662766
- new version: 1.12.0 (for radare2 4.5.1)

* Thu Dec 17 2020 umeabot <umeabot> 1.11.0-2.mga8
+ Revision: 1659723
- Rebuild for new Qt5

* Sun Aug 02 2020 daviddavid <daviddavid> 1.11.0-1.mga8
+ Revision: 1610530
- new version: 1.11.0 (for radare2 4.5.0)

* Wed Jul 22 2020 daviddavid <daviddavid> 1.10.3-2.mga8
+ Revision: 1607786
- add upstream patch to fix build with Qt 5.15

* Sat May 23 2020 daviddavid <daviddavid> 1.10.3-1.mga8
+ Revision: 1586921
- new version: 1.10.3 (for radare2 4.4.0)

* Tue Mar 31 2020 daviddavid <daviddavid> 1.10.2-1.mga8
+ Revision: 1562521
- new version: 1.10.2

* Thu Feb 20 2020 daviddavid <daviddavid> 1.10.1-1.mga8
+ Revision: 1547592
- new version: 1.10.1 (for radare2 4.2.1)

* Sat Dec 28 2019 daviddavid <daviddavid> 1.10.0-1.mga8
+ Revision: 1474583
- new version: 1.10.0 (for radare2 4.1.1)

* Wed Oct 02 2019 daviddavid <daviddavid> 1.9.0-1.mga8
+ Revision: 1448858
- new version: 1.9.0 (for radare2 3.8.0)

* Wed Jul 17 2019 daviddavid <daviddavid> 1.8.3-1.mga8
+ Revision: 1421995
- new version: 1.8.3

* Thu Apr 18 2019 daviddavid <daviddavid> 1.8.1-1.mga7
+ Revision: 1393121
- new version: 1.8.1

* Wed Apr 03 2019 daviddavid <daviddavid> 1.8.0-1.mga7
+ Revision: 1385508
- new version: 1.8.0

* Mon Apr 01 2019 umeabot <umeabot> 1.7.4-2.git20190309.2.mga7
+ Revision: 1384671
- Qt5 Rebuild

* Sat Mar 09 2019 daviddavid <daviddavid> 1.7.4-2.git20190309.1.mga7
+ Revision: 1373050
- update to latest git snapshot to make it build with radare2 3.0.0
- rebuild for new radare2 3.3.0

* Wed Jan 23 2019 daviddavid <daviddavid> 1.7.4-1.mga7
+ Revision: 1359945
- new version: 1.7.4

* Mon Jan 14 2019 daviddavid <daviddavid> 1.7.3-1.mga7
+ Revision: 1356396
- new version: 1.7.3

* Tue Jan 08 2019 daviddavid <daviddavid> 1.7.1-2.mga7
+ Revision: 1351631
- rebuild for new Python 3.7

* Mon Oct 01 2018 daviddavid <daviddavid> 1.7.1-1.mga7
+ Revision: 1313105
- new version: 1.7.1
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild

* Sun May 20 2018 daviddavid <daviddavid> 1.4-1.mga7
+ Revision: 1230801
- initial package radare2-cutter

